VERSION 5.00
Begin VB.Form SendImage 
   Caption         =   "Send Image"
   ClientHeight    =   4635
   ClientLeft      =   240
   ClientTop       =   3750
   ClientWidth     =   7635
   FontTransparent =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   4635
   ScaleWidth      =   7635
   Begin VB.ComboBox PatternCombo 
      Height          =   315
      Left            =   0
      TabIndex        =   4
      Text            =   "Combo1"
      Top             =   3360
      Width           =   2655
   End
   Begin VB.FileListBox FileList 
      Height          =   1845
      Left            =   0
      TabIndex        =   3
      Top             =   1440
      Width           =   2655
   End
   Begin VB.DirListBox DirList 
      Height          =   990
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   2655
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   2175
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   4215
      Left            =   2760
      ScaleHeight     =   4155
      ScaleWidth      =   4635
      TabIndex        =   0
      Top             =   120
      Width           =   4695
   End
   Begin VB.Menu mnuPaste 
      Caption         =   "Paste"
   End
   Begin VB.Menu mnuCut 
      Caption         =   "Cut"
   End
   Begin VB.Menu mnuSent 
      Caption         =   "Send to TextBox"
   End
End
Attribute VB_Name = "SendImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_PASTE = &H302


Private Sub Form_GotFocus()
Picture1.BorderStyle = 1
End Sub


Private Sub Form_LostFocus()
Picture1.BorderStyle = 0
End Sub


Private Sub mnuCut_Click()
If TypeOf Screen.ActiveControl Is PictureBox Then
Screen.ActiveControl.Picture = LoadPicture()
End If
End Sub

Private Sub mnuPaste_Click()
If TypeOf Screen.ActiveControl Is PictureBox Then
Screen.ActiveControl.Picture = Clipboard.GetData()
End If
End Sub

Private Sub mnuSent_Click()
On Error GoTo colorerror
' Copy the picture into the clipboard.
    Clipboard.Clear
    Clipboard.SetData Picture1.Picture
    
    ' Paste the picture into the RichTextBox.
    SendMessage frmText.rtfTextEditor.hwnd, WM_PASTE, 0, 0
SendImage.Hide
Exit Sub
colorerror:
End Sub

Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DriveList_Change()
    On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


Private Sub FileList_Click()
Dim FName As String

    On Error GoTo LoadPictureError

    FName = FileList.Path + "\" + FileList.Filename
    Caption = "Viewer [" & FName & "]"
    
    MousePointer = vbHourglass
    DoEvents
    Picture1.Picture = LoadPicture(FName)
    MousePointer = vbDefault
    Exit Sub

LoadPictureError:
    Beep
    MousePointer = vbDefault
    Caption = "Viewer [Invalid picture]"
    Exit Sub
End Sub

Private Sub Form_Load()
     Call sCenterForm(Me)
    PatternCombo.AddItem "Bitmaps (*.bmp)"
    PatternCombo.AddItem "GIF (*.gif)"
    PatternCombo.AddItem "JPEG (*.jpg)"
    'PatternCombo.AddItem "Icons (*.ico)"
    PatternCombo.AddItem "Matafiles (*.wmf)"
    PatternCombo.AddItem "TIF (*.tif)"
    'PatternCombo.AddItem "DIBs (*.dib)"
    'PatternCombo.AddItem "Graphic (*.gif;*.jpg;*.ico;*.bmp;*.wmf;*.dib)"
    PatternCombo.AddItem "Graphic (*.gif;*.jpg;*.bmp;*.wmf;*.tif)"
    'PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = 0
End Sub

Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move GAP, GAP, wid
    PatternCombo.Move GAP, ScaleHeight - PatternCombo.Height, wid
    
    hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height - 3 * GAP) / 2
    If hgt < 100 Then hgt = 100
    DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt
    FileList.Move GAP, DirList.Top + DirList.Height + GAP, wid, hgt
End Sub


Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.List(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub



