VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Ruler"
   ClientHeight    =   3915
   ClientLeft      =   165
   ClientTop       =   375
   ClientWidth     =   6510
   LinkTopic       =   "Form1"
   ScaleHeight     =   3915
   ScaleWidth      =   6510
   Begin VB.PictureBox HRuler 
      AutoRedraw      =   -1  'True
      Height          =   495
      Left            =   0
      ScaleHeight     =   435
      ScaleWidth      =   6435
      TabIndex        =   0
      Top             =   0
      Width           =   6495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim X1 As Single
'Create the Ruler
Private Sub DrawRuler(MSize)
    Dim Sincr As Single, RScale As Integer
    'Scalemode is in TWIPS 1440 per inch
    RScale = 1440
    'Number of segment across form
    Sincr = RScale / MSize
    Do While Sincr < HRuler.ScaleWidth
        'Number of sections
        For I = 1 To MSize
            'Size of Tics
            If I = MSize Then
                HRuler.Line (Sincr, 0)-(Sincr, HRuler.ScaleHeight)
                HRuler.CurrentY = 0
                HRuler.Print Int(Sincr / RScale)
            Else
                If I = Int(MSize * 0.75) Then
                    HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.25))-(Sincr, HRuler.ScaleHeight)
                Else
                    If I = Int(MSize * 0.5) Then
                        HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.5))-(Sincr, HRuler.ScaleHeight)
                    Else
                        If I = MSize * 0.25 Then
                            HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.25))-(Sincr, HRuler.ScaleHeight)
                        Else
                            HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.125))-(Sincr, HRuler.ScaleHeight)
                        End If
                    End If
                End If
            End If
            Sincr = Sincr + (RScale / MSize)
        Next
    Loop
End Sub
Private Sub Form_Load()
    HRuler.Width = Form1.ScaleWidth - HRuler.Left
    Form1.Show
    'Draw Ruler 16ths of an inch
    DrawRuler 32
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    HRuler.DrawMode = 6
    HRuler.Line (X, 0)-(X, HRuler.ScaleHeight)
    If X1 > 0 Then
        HRuler.Line (X1, 0)-(X1, HRuler.ScaleHeight)
    End If
    HRuler.DrawMode = 13
    X1 = X
End Sub

Private Sub Form_Resize()
    HRuler.Width = Form1.ScaleWidth - HRuler.Left
    HRuler.Cls
    X1 = 0
    'Draw Ruler 16ths of an inch
    DrawRuler 32
End Sub
